const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const class_messages = sequelize.define(
    'class_messages',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      content: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  class_messages.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.class_messages.belongsTo(db.users, {
      as: 'sender',
      foreignKey: {
        name: 'senderId',
      },
      constraints: false,
    });

    db.class_messages.belongsTo(db.schools, {
      as: 'schools',
      foreignKey: {
        name: 'schoolsId',
      },
      constraints: false,
    });

    db.class_messages.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.class_messages.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return class_messages;
};
